/* 
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993  Arizona Board of Regents
 *
 */

#ifndef haval_i_h
#define haval_i_h

typedef long 	HAVALhdr;
typedef long 	HAVALtype;
typedef XObj  	PassiveId; 


#define IP_PSHDR_FLAG	  1
#define ALL_PARTS     	  4
#define HAVAL_TRAILERS     8
#define HAVAL_SECRETAPPEND  16
#define USE_IPSEC         32

#define TRANSPORT_PROTOCOL 0
#define KM_PROTL_OUT	   1
#define KM_PROTL_IN	   2
#define KM_PROTL	   KM_PROTL_OUT

#define HAVAL_SIZE 128

#define xGetParticipants(lls, buf, n, p) \
  xControl(lls, GETPARTICIPANTS, buf, n); \
  partInternalize(p, buf);

#define MAX_PREFIX 64

typedef struct {
    Part     p[2];
    long     flags; /* &1 turns on IPpseudoheader length-fixup for session */
    long     LprefixL;       /* Length of any local prefix, in bytes */
    unsigned char *Lprefix;  /* pointer to local prefix */
    long     RprefixL;       /* Length of any remote prefix, in bytes */
    unsigned char *Rprefix;  /* pointer to remote prefix */
    /* Lprefix = Rprefix is ok, as long as LprefixL = RprefixL */
} SState;    /* session state */

typedef XObj ActiveId;

typedef struct {
    Map	     actMap;
    Map      pasMap;
    long     flags;  /* &1 turns on IPpseudoheader length-fixup for protocol
			&4 turns on using both participants for key 
			&8 puts checksum at the end of the message 
			&16 puts secret on both sides of message */
} PState;    /* protocol state */



#define	HAVAL_ACTIVE_MAP_SZ	257
#define	HAVAL_PASSIVE_MAP_SZ	13

#endif
