/*     
 * $RCSfile: authuser.c,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: authuser.c,v $
 * Revision 1.2.1.1  1994/02/08 19:24:06  menze
 * renamed to authuser
 *
 */

#include "xkernel.h"

#define MAX_CLIENT_LEN 20
#define MAX_PASSWD_LEN 20

#ifdef __STDC__

void user_auth_request(Event, void *);
void authuser_init(XObj);

#else

void user_auth_request();
void authuser_init();

#endif

int traceauthuserp = 1;



void
authuser_init(self)
     XObj self;
{
  xTraceP0(self, TR_MAJOR_EVENTS, "init entered.");
  evDetach(evSchedule(user_auth_request, (void *)self, 0));
}

void user_auth_request(ev, arg)
     Event ev;
     void *arg;
{
  XObj self = (XObj)arg;
  Part part[1];
  char *name;
  char *passwd;

  xTraceP0(self, TR_MAJOR_EVENTS, "request entered.");

  name = (char *)xMalloc(MAX_CLIENT_LEN);
  strcpy(name, "dcs");

  passwd = (char *)xMalloc(MAX_PASSWD_LEN);
  strcpy(passwd, "growingDiscon10t");
  /*strcpy(passwd, "frowingDiscon10t");*/

  partInit(part, 1);
  partPush(part[0], name, MAX_CLIENT_LEN);
  partPush(part[0], passwd, MAX_PASSWD_LEN);

  xTraceP0(self, TR_EVENTS, "about to open auth");
  xOpen(self, self, xGetDown(self, 0), part);
}

