/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.2
 * 
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: sem.c,v $
 *
 * HISTORY
 * $Log: sem.c,v $
 * Revision 1.2  1994/06/11 00:02:24  menze
 * Added copyright notice
 *
 * Revision 1.1  1994/05/15  00:20:19  davidm
 * Initial revision
 *
 */
/*
 * Counting semaphores implemented on top of threads package.
 */
#include "platform.h"
#include "scout_thread.h"


void
semInit(Semaphore *s, u_int initialVal)
{
    s->count = initialVal;
    scout_queue_init(&s->waitingQ);
} /* semInit */


void
semWait(Semaphore *s)
{
    if (--s->count < 0) {
	scout_queue_append(&s->waitingQ, scout_thread_self());
	scout_thread_suspend();
    } /* if */
} /* semWait */


void
semSignal(Semaphore *s)
{
    Scout_Thread *t;

    if (s->count++ < 0) {
	t = scout_queue_remove(&s->waitingQ);
	scout_thread_wakeup(t);
    } /* if */
} /* semSignal */

			/*** end of sem.c ***/
